require "AudioEngine"

local Common = {}

Common.config = {buttonFontSize = 20 ,buttonHeight = 50,
buttonWidth = 126,picGroopNumber = 4,totalMissionLevel = 30,buttonFontSize = 20}

--可视范围
Common.visibleSize = CCDirector:sharedDirector():getVisibleSize()

local delayTime = 0
local clickExitTimes = 0

local scheduler = CCDirector:sharedDirector():getScheduler()
local schdeule2
local exitLabel

local function stopDelayTimeSchedule()
	scheduler:unscheduleScriptEntry(schdeule2)
end

local function countDelayTime()
	delayTime = delayTime + 1
	if delayTime == 3 then 
		stopDelayTimeSchedule()
		clickExitTimes = 0
		delayTime = 0
		CCDirector:sharedDirector():getRunningScene():removeChild(exitLabel,true)
   	end 
end 

local function startDelayTimeSchdeule()
	schdeule2 = scheduler:scheduleScriptFunc(countDelayTime,1,false) 
end

-- for CCLuaEngine traceback
function Common.__G__TRACKBACK__(msg)
print("----------------------------------------")
print("LUA ERROR: " .. tostring(msg) .. "\n")
print(debug.traceback())
print("----------------------------------------")
end

function  Common.keyEventListener(callback) 
    if callback == "backClicked"  then
       if clickExitTimes == 0 then 
       		exitLabel = CCLabelTTF:create (Common.getLabelByKey("exitInfo"), "Marker Felt", Common.config["buttonFontSize"])	
			exitLabel:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 4)
			CCDirector:sharedDirector():getRunningScene():addChild(exitLabel)
       		startDelayTimeSchdeule()
       		clickExitTimes = 1
       else
      		os.exit()
   	   end 
	end
end

--切换场景
function Common.runScene(scene)
	local runningScene = CCDirector:sharedDirector():getRunningScene() 
	if(runningScene) then
		CCDirector:sharedDirector():replaceScene(scene)
	
	else
		CCDirector:sharedDirector():runWithScene(scene)
	end
end

--根据key获取resource.xml资源内容
function Common.getLabelByKey(key)
	local dict = CCDictionary:createWithContentsOfFile("resource.xml")
 	local value = dict:valueForKey(key):getCString()
	return value
end

--根据key获取missiondata.xml关卡资源内容
function Common.getDataByKey(key)
	local dict = CCDictionary:createWithContentsOfFile("missiondata.xml")
 	local value = dict:valueForKey(key):getCString()
	return value
end

--获取某数组的元素个数
function Common.getTableCount(tbl)
	local count = 0
	for key,value in pairs(tbl) do
		count =count +1
	end
	return count
end

function Common.isOdd(num)
	if num%2 ==0 then 
		return false 
	else
		return true
	end

end 

--判断数组是否包含某key
function Common.isTableContain(tbl,curKey)
	for key,value in pairs(tbl) do
		if key == curKey then
			return true
		end
	end
	return false
end

--根据指定字段从数组中找到值
function Common.findObjInArrayByFindword(array,field,findWord)
	for i=1,#array  do
		local value = array[i]
		if value[field] == findWord then
			local returnVal = {}
			returnVal["position"] = i
			returnVal["value"] = value
			return returnVal
		end
	end
	return nil
end

--根据keyword从数组中找到值
function Common.findObjInArrayByKeyword(array,keyword)
	for i=1,#array  do
		local value = array[i]
		if value["keyword"] == keyword then
			local returnVal = {}
			returnVal["position"] = i
			returnVal["value"] = value
			return returnVal
		end
	end
	return nil
end

--判断数组是否包含某值
function Common.isArrayContainByKeyword(array,curValue)
	for i=1,#array  do
		local value = array[i]
		if value["keyword"] == curValue["keyword"] then
			return true
		end
	end
	return false
end

--判断数组是否包含某值
function _deleteFromArrayByKeyword(array,curValue)
	for key,value in ipairs(array) do
		if value["keyword"] == curValue["keyword"] then
			table.remove(array,key)
		end
	end
end


--判断数组是否包含某值
function Common.deleteFromArrayByKeyword(array,curValue)
	_deleteFromArrayByKeyword(array,curValue)
end

--判断数组是否包含某值
function Common.deleteArrayFromArrayByKeyword(parent,sub)
	for i=1,#array do
		local value = array[i]
		_deleteFromArrayByKeyword(parent,value)
	end

end

cclog = function(...)
print(string.format(...))
end

local function copyTable(sourceTable)
	local tab = {}
    for k, v in pairs(sourceTable or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyTable(v)
        end
    end
    for k, v in ipairs(sourceTable or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyTable(v)
        end
    end
    
    return tab
end 

--将一个Table的所有元素拷贝到一个空Table
function Common.copyTable(sourceTable)
	local tab = copyTable(sourceTable)
	return tab
end

local function copyArray(sourceTable)
	local tab = {}
    for k, v in ipairs(sourceTable or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyArray(v)
        end
    end
    for k, v in pairs(sourceTable or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyTable(v)
        end
    end
    
    return tab
end 

--将一个Table的所有元素拷贝到一个空Table
function Common.copyArray(sourceTable)
	local tab = copyArray(sourceTable)
	return tab 
end

cclog = function(...)
print(string.format(...))
end

function Common.saveScore(curScore)
	local curMissionLevel = CCUserDefault:sharedUserDefault():getIntegerForKey("curMissionLevel")
	if curMissionLevel == 0 then curMissionLevel = 1 end
	curMissionLevel=curMissionLevel+1


	local oldScore = CCUserDefault:sharedUserDefault():getIntegerForKey("score")
	local score = oldScore + curScore
	local lastScore = CCUserDefault:sharedUserDefault():getIntegerForKey("lastScore")
	if lastScore == 0 then
		lastScore = score		
	else
		if  lastScore >= score then
		else
			lastScore = score
		end
	end
	CCUserDefault:sharedUserDefault():setIntegerForKey("lastScore",lastScore)
	CCUserDefault:sharedUserDefault():setIntegerForKey("score",score)
	CCUserDefault:sharedUserDefault():setIntegerForKey("curMissionLevel",curMissionLevel)
	CCUserDefault:sharedUserDefault():flush()
end


function Common.getIntPart(x)
    if x <= 0 then
       return math.ceil(x);
    end

    if math.ceil(x) == x then
       x = math.ceil(x);
    else
       x = math.ceil(x) - 1;
    end
    return x;
end


function Common.changeButtonImage(bt,img)
	local text2d = CCTextureCache:sharedTextureCache():addImage(img)
  	bt:setTexture(text2d)

end

function Common.isBeTouched(touchP,sprite)
		spritePositionX,spritePositionY = sprite:getPosition()
		local spriteWorldPosition = sprite:getParent():convertToWorldSpace(ccp(spritePositionX,spritePositionY))
		local spriteSize = sprite:getContentSize()
        local rect = CCRectMake(spriteWorldPosition.x - spriteSize.width/2, spriteWorldPosition.y - spriteSize.height/2,spriteSize.width, spriteSize.height)      
        if rect:containsPoint(touchP)   then
			return true
		end
		return false
end

function Common.playMusic(musicPath)
	AudioEngine.playMusic(musicPath, true)
end

function Common.playEffect(effectPath)
	AudioEngine.stopAllEffects()
	AudioEngine.playEffect(effectPath, false)
end

function Common.doOnEnterTransitionFinish()
	runtimeData.stopScene = 0
end

function Common.eventHandler(eventType)
	if eventType == "enterTransitionFinish" then
		doOnEnterTransitionFinish()
	end
end

--将successScene注册到全局对象表中
local modename = "Common"
local proxy = {}
local mt    = {
    __index = Common,
    __newindex =  function (t ,k ,v)
        print("attemp to update a read-only table")
    end
} 
setmetatable(proxy,mt)
_G[modename] = proxy
package.loaded[modename] = proxy