local HelpScene = {}

local mainLayer


-- create mainLayer
local function createStartLayer()

	local bg = CCSprite:create("img/helpBg.jpg")
	bg:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 2)
	mainLayer = CCLayer:create()
	mainLayer:addChild(bg)
	mainLayer:setKeypadEnabled(true)
	mainLayer:registerScriptKeypadHandler(function(callback) Common.keyEventListener(callback) end) 

	local backButton = CCSprite:create("img/buttons/back.png")
	local backButtonSize = backButton:getContentSize()
	backButton:setPosition(10+backButtonSize.width/2,Common.visibleSize.height-backButtonSize.height/2-10)
	mainLayer:addChild(backButton)

	local backButtonBindBox = backButton:boundingBox()

	local function onTouchBegan(x, y)			
		return true
	end

	local function onTouchMoved(x, y)

	end

	local function onTouchEnded(x, y)
		local touchP = ccp(x,y)

		if backButtonBindBox:containsPoint(touchP) then 
			local mssionScene = StartScene.createScene()
			local transitionFade  = CCTransitionFade:create(1,mssionScene) 
			CCDirector:sharedDirector():replaceScene(transitionFade)
		end 
	end

	local function onTouch(eventType, x, y)
		if eventType == "began" then
			return onTouchBegan(x, y)
			elseif eventType == "moved" then
			return onTouchMoved(x, y)
			else
			return onTouchEnded(x, y)
		end
	end

	mainLayer:registerScriptTouchHandler(onTouch)
	mainLayer:setTouchEnabled(true)
	
	return mainLayer
end

local function init()

end 

function HelpScene.createScene()
	init()
	local scene = CCScene:create()
	scene:addChild(createStartLayer())
	Common.runScene(scene)

	return scene
end

--将successScene注册到全局对象表中
local modename = "HelpScene"
local proxy = {}
local mt    = {
    __index = HelpScene,
    __newindex =  function (t ,k ,v)
        print("attemp to update a read-only table")
    end
} 
setmetatable(proxy,mt)
_G[modename] = proxy
package.loaded[modename] = proxy




