local MainScene = {}
local mainLayer

--格子物体
local gridObjs
--x轴方格数
local xNum
--y轴方格数
local yNum
--可连接对数
local objectslimit
--关卡数
local levelNum
--可穿越方格列表
local canCrossGrids
--生成用临时射线对象
local tempSegments
--方格参数
local gridConfig
--缩放系数
local scale
--连接对象
local linkObjs
--当前触摸的连接对象linkword
local curLinkword
--前一个连接格子
local preLinkGrid
--前前一个连接格子
local prePreLinkGrid
--当前操作已处理的格子
local curMovedKeyword
--游戏进行标志
local isPlay
--图片
local imgs
--关卡是否已存在
local isLevelExsit

local showLinkTipsLabel

local scheduler
local scheduler1
local frameCache
local batchNode
local curMission
local curLevel
local isNoFinishMode
local isCloseSound
local startEffectPath

--把函数赋值给变量，优化性能
local fun_findObjInArrayByKeyword = Common.findObjInArrayByKeyword

local function createGrids(isDraw)
	--格子的原始尺寸
	local gridOriSize={width=170,height=170}
	--活动区域参数
	local area = {}
	area.width = Common.visibleSize.width-20
	area.height = area.width
	area.xNum = xNum
	area.yNum = yNum	
	--标定格子参数
	
	gridConfig.width = area.width/area.xNum
	gridConfig.height=gridConfig.width

	--以上参数以后从全局配置获取
	--原始格子的缩放比例
	scale = gridConfig.width/gridOriSize.width
	local startX = (Common.visibleSize.width - area.width)/2
	local startY = 150

	--生成格子
	for  i=1,xNum do
		for  j=1,yNum do
			local grid 
			if isDraw then 
				grid = CCSprite:createWithSpriteFrameName("grid.png");
				grid:setScale(scale)
				local gridSize = grid:getContentSize()	
				local nomorwidth = 100		
				grid:setPosition(startX+gridConfig.width*(i+0.5-1),startY+gridConfig.height*(j+0.5-1))
				batchNode:addChild(grid)
			end 

			--创建格子对象并放入数组
			local gridObj = {}
			if isDraw then 
				gridObj["sprite"] = grid
			end 
			local keyword = i..","..j
			gridObj["keyword"] = keyword
			gridObj["x"] = i
			gridObj["y"] = j
			table.insert(gridObjs,gridObj)
		end
	end
end

local function hasTwoMoreNeighbor(point,pointsList) 
	local allPoints = Common.copyArray(pointsList)			
	table.insert(allPoints,point)
	for k,v in ipairs(allPoints) do
		local neighborCount = 0
		point["neighbors"]={}
		for direction=1,4 do 
			if  direction == 1 then 
					x = point.x 
					y = point.y+1
			elseif direction == 2  then 
				x = point.x+1 
				y = point.y
			elseif direction == 3  then 
				x = point.x 
				y = point.y-1
			else	
				x = point.x -1
				y = point.y
			end
			local grid = {}
			grid["x"]=x
			grid["y"]=y
			grid["keyword"]=x..","..y
			if Common.isArrayContainByKeyword(canCrossGrids,grid) then
				if k==#allPoints then
					if 	neighborCount < 2 then 
						table.insert(point["neighbors"],grid)
					end
				end  	
				neighborCount = neighborCount+1
			end
		end 
		if neighborCount<2 then 
			return false 
		end 
	end
	return true
end

local function createPoint(pointsList)
		local position=math.random(1,#canCrossGrids)
		local point = canCrossGrids[position]
		if not Common.isArrayContainByKeyword(pointsList,point) then 				
			return point
		else 
			return createPoint(pointsList)
		end 

end

local function createPoints()
	canCrossGrids = Common.copyArray(gridObjs)
	local pointsList={}
	local pointCount = 0
	math.randomseed(tostring(os.time()):reverse():sub(1, 6))  
	while pointCount < objectslimit do
		local point = createPoint(pointsList)
		if hasTwoMoreNeighbor(point,pointsList) then 			
			table.insert(pointsList,point)
			Common.deleteFromArrayByKeyword(canCrossGrids,point)
			for k,v in ipairs(point["neighbors"]) do 
				Common.deleteFromArrayByKeyword(canCrossGrids,v)
			end
			pointCount = pointCount +1
		end 
	end
	return pointsList
end

local function findNeighbor(point,canCrossGrids)
	for direction=1,4 do 
		if  direction == 1 then 
				x = point.x 
				y = point.y+1
		elseif direction == 2  then 
			x = point.x+1 
			y = point.y
		elseif direction == 3  then 
			x = point.x 
			y = point.y-1
		else	
			x = point.x -1
			y = point.y
		end
		local grid = {}
		grid["x"]=x
		grid["y"]=y
		grid["keyword"]=x..","..y
		if (Common.isArrayContainByKeyword(canCrossGrids,grid)) then
			return grid
		end
	end 
	return nil
end  

local function createLines(pointsList)
	
--	Common.deleteArrayFromArrayByKeyword(canCrossGrids,pointsList)
	for key,value in ipairs(pointsList) do 
		local tempSegment = {}
		--关键，生成带中心点的两端放射线
		tempSegment["keyword"] = value.x..","..value.y
		tempSegment["mPoint"] = value
		tempSegment["lines"] = {}
		for k,v in ipairs(value["neighbors"]) do 
			local line={}
			v["type"] = "line"
			table.insert(line,v)
			table.insert(tempSegment["lines"],line)
--			Common.deleteFromArrayByKeyword(canCrossGrids,v)
		end 
		table.insert(tempSegments,tempSegment)
	end 
	local tempImgs = Common.copyArray(imgs)
	for key,value in ipairs(tempSegments) do
		local position = math.random(1,#tempImgs)
		local img = tempImgs[position]
		value["img"] = img["fileName"] 
		value["color"] = img["color"] 
		for k,v in ipairs(value["lines"]) do 
			while v[#v]["type"] == "line" do
				local neighborPoint = findNeighbor(v[#v],canCrossGrids)
				if neighborPoint then
					neighborPoint["type"] = "line"
					table.insert(v,neighborPoint)
					Common.deleteFromArrayByKeyword(canCrossGrids,neighborPoint)
				else 
					v[#v]["type"] = "end"
				end
			end 
		end
		table.remove(tempImgs,position)
	end
end 

local function createLine(prePoint,curPoint,nextPoint,color,isDraw)
	local lineType=""
	local direction = ""
	local px
	local py
	local cx = tonumber(curPoint["x"])
	local cy = tonumber(curPoint["y"])
	local nx
	local ny
	if nextPoint == nil  then 
		px = tonumber(prePoint["x"])
		py = tonumber(prePoint["y"])
	elseif prePoint==nil then 
		nx = tonumber(nextPoint["x"])
		ny = tonumber(nextPoint["y"])
	else 
		nx = tonumber(nextPoint["x"])
		ny = tonumber(nextPoint["y"])
		px = tonumber(prePoint["x"])
		py = tonumber(prePoint["y"])
	end 


	if nextPoint == nil or prePoint==nil then 
		lineType="b"
	else 
		lineType="q"
	end 

	local imgName=""
	if lineType == "b" then 
		imgName = "line_bz.png"
		if nextPoint == nil then 
			if px > cx then 
				direction = direction .. "y"
			elseif px < cx then 
				direction = direction .. "z"
			end
			if py >cy then
				direction = direction .. "s"
			elseif py < cy then 
				direction = direction .. "x"
			end 
		elseif prePoint == nil then 
			if nx > cx then 
				direction = direction .. "y"
			elseif nx < cx then 
				direction = direction .. "z"
			end
			if ny >cy then
				direction = direction .. "s"
			elseif ny < cy then 
				direction = direction .. "x"
			end 
		end 
	elseif lineType == "q" then
		if nx > cx then 
			direction = direction .. "y"
		elseif nx < cx then 
			direction = direction .. "z"
		end
		if ny > cy then
			direction = direction .. "s"
		elseif ny < cy then 
			direction = direction .. "x"
		end 
		if px > cx then 
			direction = direction .. "y"
		elseif px < cx then 
			direction = direction .. "z"
		end
		if py >cy then
			direction = direction .. "s"
		elseif py < cy then 
			direction = direction .. "x"
		end 
		if direction == "yz" or direction == "zy" or direction == "z" or direction == "y" or direction == "sx" or direction == "xs" or direction == "s" or direction == "x"  then 
			imgName = "line_z.png"
		else 
			imgName = "line_w.png"
		end 
	end 
--画线
	if isDraw == nil or isDraw ~=false then

	--弯角缩减参数
		local xb = 0
		local yb = 0
		local cj = 31.5
		local line  = CCSprite:createWithSpriteFrameName(imgName)
		line:setColor(color)
		local rotation = 0
		local anchorPoint = ccp(0.5,0.5)
		if  direction == "s" then 	
			rotation= 90
			anchorPoint = ccp(1,0.5)
		elseif  direction == "x" then 
			rotation = 90
			anchorPoint = ccp(0,0.5)
		elseif direction == "z" then 
			anchorPoint = ccp(1,0.5)
		elseif direction == "y"  then 
			anchorPoint = ccp(0,0.5)
		elseif direction == "sx" or direction == "xs"  then 
			rotation = 90
			anchorPoint = ccp(0.5,0.5)
		elseif direction == "yz" or direction == "zy" then 
			anchorPoint = ccp(0.5,0.5)
		elseif direction == "ys" or direction == "sy" then 
			rotation = 180
			anchorPoint = ccp(0.5,0.5)
			xb = -cj*scale
			yb = -cj*scale
		elseif direction == "yx" or direction == "xy" then 
			rotation = 270
			anchorPoint = ccp(0.5,0.5)
			xb = -cj*scale
			yb = cj*scale
		elseif direction == "zs" or direction == "sz" then 
			rotation = 90
			anchorPoint = ccp(0.5,0.5)
			xb = cj*scale
			yb = -cj*scale
		elseif direction == "zx" or direction == "xz" then 
			anchorPoint = ccp(0.5,0.5)
			xb = cj*scale
			yb = cj*scale
		else 
		end
		line:setScale(scale)
		line:setRotation(rotation)
		line:setAnchorPoint(anchorPoint)
		local grid = fun_findObjInArrayByKeyword(gridObjs,curPoint["x"]..","..curPoint["y"])["value"]
		line:setPosition(grid["sprite"]:getPositionX()-xb,grid["sprite"]:getPositionY()-yb)
		batchNode:addChild(line)
		batchNode:reorderChild(line,1)
		return line
	end 
	return nil

end 

local function createSegment(isDraw)
	for key,value in ipairs(tempSegments) do 
		local color = value["color"]
		createLine(value["lines"][1][1],value["mPoint"],value["lines"][2][1],color,isDraw)
		for k,v in ipairs(value["lines"]) do 
			for k1,v1 in ipairs(v) do 
				if v1.type == "end" then 					
					if k1==1 then
						createLine(value["mPoint"],v1,nil,color,isDraw)
					else
						createLine(v[k1-1],v1,nil,color,isDraw)
					end
				else 
					if k1==1 then
						createLine(value["mPoint"],v1,v[k1+1],color,isDraw)
					else
						createLine(v[k1-1],v1,v[k1+1],color,isDraw)
					end
				end 
			end
		end 
	end
end 

local function createLinkObj(idDraw)
	
	for key,value in ipairs(tempSegments) do 
		local img = value["img"]
		local color = value["color"]
		local linkObj = {}
		linkObj["objImg"]=img
		linkObj["color"] = color
		linkObj["ends"]={}
		linkObj["points"] = {}
		linkObj["lock"]=false
		linkObj["keyword"]	= value["mPoint"].x..","..value["mPoint"].y
		for k,v in ipairs(value["lines"]) do 
			for k1,v1 in ipairs(v) do 
				local returnVal = fun_findObjInArrayByKeyword(gridObjs,v1["keyword"])
				local grid = returnVal["value"]
				if v1.type == "end" then 
					gridObjs[returnVal["position"]]["type"]	= "end"
					gridObjs[returnVal["position"]]["linkword"]	= value["mPoint"].x..","..value["mPoint"].y
					gridObjs[returnVal["position"]]["linkColor"] = color
					gridObjs[returnVal["position"]]["isUsed"] = true
					table.insert(linkObj["ends"],grid)
					if idDraw then 
						local sprite = CCSprite:createWithSpriteFrameName(img)					
						sprite:setPosition(grid["sprite"]:getPositionX(),grid["sprite"]:getPositionY())
						sprite:setScale(scale)
						batchNode:addChild(sprite)
						batchNode:reorderChild(sprite,2)
					end 
				end 
			end
		end 
		table.insert(linkObjs,linkObj)
	end
end 

local function drawLinkObj()
	for k,v in ipairs(linkObjs) do 
		local img = v["objImg"]
		local color = v["color"]
		local ends = v["ends"]
		for k1,v1 in ipairs(ends) do 
			local returnVal = fun_findObjInArrayByKeyword(gridObjs,v1["keyword"])
			local grid = returnVal["value"]
			local sprite = CCSprite:createWithSpriteFrameName(img)					
			sprite:setPosition(grid["sprite"]:getPositionX(),grid["sprite"]:getPositionY())
			sprite:setScale(scale)
			batchNode:addChild(sprite)
			batchNode:reorderChild(sprite,2)
		end
	end  
end 

local function stopSchedule()
	scheduler:unscheduleScriptEntry(schdeule1)
end

function checkMissionComplete()
	local isAllLock = true
	for i=1,#linkObjs do 
		local v = linkObjs[i]
		if v["lock"]==true then 
		else
			isAllLock = false
		end 
	end
	local isAllFilled = true

	for i=1,#gridObjs do 
		local v = gridObjs[i]
		if v["linkword"] == nil then 
			isAllFilled = false
		end	
	end
	if isAllLock and isAllFilled then 
		return true
	else 
		return false
	end 

end

local function checkLevelConform()

	local count = 0
	local gridsCount = xNum*yNum
	for i=1,#tempSegments do 
		local tempSegmentLines = tempSegments[i]["lines"]
		count = count + #tempSegmentLines[1]+#tempSegmentLines[2]+1
	end
	if count == gridsCount then 

		return true 
	else 
		return false 
	end  
end

local function setShade(sprite,swallow)
    swallow = swallow or false
    local spriteCp = CCSprite:createWithSpriteFrame(sprite:displayFrame())
    spriteCp:setAnchorPoint(sprite:getAnchorPoint())
    spriteCp:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 2)
    
    local spriteCpSize = spriteCp:getContentSize()       
    local startX = (Common.visibleSize.width - spriteCpSize.width )/2
    local startY = (Common.visibleSize.height - spriteCpSize.height )/2
    local congraduSprite = CCSprite:create("img/congradue.png")
    congraduSprite:setPosition(startX+spriteCpSize.width/2,startY+spriteCpSize.height*3/4)  
    local shareLabel = CCLabelTTF:create("和朋友分享你的喜悦", "Marker Felt", Common.config["buttonFontSize"])
    shareLabel:setPosition(startX+spriteCpSize.width/2-40,startY+spriteCpSize.height*2/4)
    local color=ccc3(213,37,39)
    shareLabel:setColor(color)
    local shareSprite = CCSprite:create("img/buttons/share.png")
    shareSprite:setPosition(shareLabel:getPositionX()+shareLabel:getContentSize().width/2+10+shareSprite:getContentSize().width/2,startY+spriteCpSize.height*2/4)

    local nextSprite = CCSprite:create("img/level/next.png")
    local buttonSize = nextSprite:getContentSize()
    local jj=(spriteCpSize.width - buttonSize.width*3-60)/2
    nextSprite:setPosition(startX+30+buttonSize.width/2,startY+spriteCpSize.height*1/4)
    local reloadSprite = CCSprite:create("img/level/reload.png")
    reloadSprite:setPosition(startX+30+buttonSize.width*1.5+jj,startY+spriteCpSize.height*1/4)
    local levelSprite = CCSprite:create("img/level/levelSelect.png")
    levelSprite:setPosition(startX+30+buttonSize.width*2.5+jj*2,startY+spriteCpSize.height*1/4)
    mainLayer:addChild(congraduSprite)
    mainLayer:reorderChild(congraduSprite,3)
    mainLayer:addChild(shareSprite)
    mainLayer:reorderChild(shareSprite,3)
	mainLayer:addChild(shareLabel)
    mainLayer:reorderChild(shareLabel,3)
    
    mainLayer:addChild(nextSprite)
    mainLayer:reorderChild(nextSprite,3)
    mainLayer:addChild(reloadSprite)
    mainLayer:reorderChild(reloadSprite,3)
    mainLayer:addChild(levelSprite)
    mainLayer:reorderChild(levelSprite,3)
    local b = ccBlendFunc:new()
    b.src = GL_ONE_MINUS_DST_COLOR
    b.dst = GL_ONE
    spriteCp:setBlendFunc(b)
    local maskLayer = CCLayerColor:create(ccc4(0,0,0,255*0.5))
    local maskRt = CCRenderTexture:create(Common.visibleSize.width, Common.visibleSize.height)
    maskRt:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 2)
    maskRt:begin()
    maskLayer:visit()
    spriteCp:visit()
    maskRt:endToLua()
 
    if swallow then
        local nextBoundingBox = nextSprite:boundingBox()
        local reloadBoundingBox = reloadSprite:boundingBox()
        local levelBoundingBox = levelSprite:boundingBox()
        local shareBoundingBox = shareSprite:boundingBox()
        local shareLabelBoundingBox = shareLabel:boundingBox()
 --       maskRt:setTouchEnabled(true)
 		 mainLayer:setTouchEnabled(false)
       	 maskLayer:registerScriptTouchHandler(function(e,x,y)
	            if nextBoundingBox:containsPoint(ccp(x,y)) then
	            	if isNoFinishMode ~= 1 then 
	            		if curLevel < 20  then
			            	curLevel = curLevel + 1
			            	CCUserDefault:sharedUserDefault():setIntegerForKey("mission"..curMission.."_curLevel",curLevel)
			        		CCUserDefault:sharedUserDefault():flush()
		        		end 
		        	else 
		        		CCUserDefault:sharedUserDefault():setIntegerForKey("isLoadNoFinishMode",0)
						CCUserDefault:sharedUserDefault():flush()
		        	end 	
	        		local scene = MainScene.createScene()
					local transitionFade  = CCTransitionFade:create(1,scene) 
					CCDirector:sharedDirector():replaceScene(transitionFade)
	                return false
                elseif reloadBoundingBox:containsPoint(ccp(x,y))  then
                	CCUserDefault:sharedUserDefault():setIntegerForKey("isLoadNoFinishMode",1)
					CCUserDefault:sharedUserDefault():flush()
                	local scene = MainScene.createScene()
					local transitionFade  = CCTransitionFade:create(1,scene) 
					CCDirector:sharedDirector():replaceScene(transitionFade)
                	return false
                elseif levelBoundingBox:containsPoint(ccp(x,y)) then
                	CCUserDefault:sharedUserDefault():setIntegerForKey("isNoFinishMode",0)
					CCUserDefault:sharedUserDefault():flush()
                	local scene = LevelScene.createScene()
					local transitionFade  = CCTransitionFade:create(1,scene) 
					CCDirector:sharedDirector():replaceScene(transitionFade)
                	return false
                elseif shareBoundingBox:containsPoint(ccp(x,y)) or shareLabelBoundingBox:containsPoint(ccp(x,y)) then
                	YoumiAd:shareButtonOnClick()
                	return false
	            end
	            return true
        	end)
       	 maskLayer:setTouchEnabled(true)
    end
--    return maskRt
	maskRt:addChild(spriteCp)
	maskLayer:addChild(maskRt)
	mainLayer:addChild(maskLayer)
	
end

local function clearParams()
		--格子物体
	gridObjs = {}
	--x轴方格数
	xNum=objectslimit - 1
	--y轴方格数
	yNum=xNum
	--可穿越方格列表
	canCrossGrids = {}
	--生成用临时射线对象
	tempSegments = {}
	--方格参数
	gridConfig = {}
	--连接对象
	linkObjs={}
	imgs = {}

end 

local function endScene()
	YoumiAd:hideBanner()
	isPlay = false
	stopSchedule()
	clearParams()	
end 

local function completeMission()
	if isNoFinishMode ~= 1 then 
		local maxOpenLevel = CCUserDefault:sharedUserDefault():getIntegerForKey("mission"..curMission.."_maxOpenLevel")
		if curLevel == maxOpenLevel then
			CCUserDefault:sharedUserDefault():setIntegerForKey("mission"..curMission.."_maxOpenLevel",maxOpenLevel+1)
		elseif maxOpenLevel==0 then 
			CCUserDefault:sharedUserDefault():setIntegerForKey("mission"..curMission.."_maxOpenLevel",maxOpenLevel+2)		
		end 
		if curMission == 9 and curLevel == 20 then 
			CCUserDefault:sharedUserDefault():setIntegerForKey("isAllMissionDone",1)
		end 
	end 
		
	local playCount = CCUserDefault:sharedUserDefault():getIntegerForKey("playCount")
	playCount = playCount + 1
	CCUserDefault:sharedUserDefault():setIntegerForKey("playCount",playCount)
	CCUserDefault:sharedUserDefault():flush()	
	local zzSprite = CCSprite:create("img/level/finishBg.png")
	setShade(zzSprite,true)
	if tonumber(playCount)%10==0 then 
		YoumiAd:showSpotAd()
	end
end 


local function updatePerSecond()
	if isPlay and checkMissionComplete()  then 	
		completeMission()		
		endScene()					
	end 

end 

local function startSchdeule()
	schdeule1 = scheduler:scheduleScriptFunc(updatePerSecond,1,false) 
end

local function isConform()
	createSegment(false)
	return  checkLevelConform()
end	

local function initParams()
	scheduler = CCDirector:sharedDirector():getScheduler()
	--关卡数
	levelNum = CCUserDefault:sharedUserDefault():getIntegerForKey("levelNum")
	curMission = CCUserDefault:sharedUserDefault():getIntegerForKey("curMission")
	curLevel = CCUserDefault:sharedUserDefault():getIntegerForKey("mission"..curMission.."_curLevel")
	--可连接对数
	objectslimit = CCUserDefault:sharedUserDefault():getIntegerForKey("objectslimit")
		--格子物体
	gridObjs = {}
	--x轴方格数
	xNum=objectslimit - 1
	--y轴方格数
	yNum=xNum
	--可穿越方格列表
	canCrossGrids = {}
	--生成用临时射线对象
	tempSegments = {}
	--方格参数
	gridConfig = {}
	--连接对象
	linkObjs={}
	--当前触摸的连接对象linkword
	curLinkword=nil
	--前一个连接格子
	preLinkGrid=nil

	--前前一个连接格子
	prePreLinkGrid=nil
	--游戏进行标志
	isPlay = true
	startEffectPath = CCFileUtils:sharedFileUtils():fullPathForFilename("sound/start.mp3")

	imgs = {{fileName = "ball_1.png", color=ccc3(225,178,62)},{fileName = "ball_2.png",color=ccc3(11,69,106)},
	{fileName = "ball_3.png",color=ccc3(213,37,39)},{fileName = "ball_4.png",color=ccc3(43,33,102)},
	{fileName = "ball_5.png",color=ccc3(239,91,39)},{fileName = "ball_6.png",color=ccc3(28,89,47)},
	{fileName = "ball_7.png",color=ccc3(136,22,24)},{fileName = "ball_8.png",color=ccc3(64,63,59)},
	{fileName = "ball_9.png",color=ccc3(221,171,50)},{fileName = "ball_10.png",color=ccc3(10,72,109)},
	{fileName = "ball_11.png",color=ccc3(218,38,41)},{fileName = "ball_12.png",color=ccc3(53,37,302)},
	{fileName = "ball_13.png",color=ccc3(242,101,41)},{fileName = "ball_14.png",color=ccc3(27,87,46)},
	{fileName = "ball_15.png",color=ccc3(137,21,24)}}
end 

local function reLoadLinkParam()
	gridObjs = {}
	tempSegments = {}
	--连接对象
	linkObjs={}
	--当前触摸的连接对象linkword
	curLinkword=nil
	--前一个连接格子
	preLinkGrid=nil
	--前前一个连接格子
	prePreLinkGrid=nil
end 

local function drawGrids()
		--格子的原始尺寸
	local gridOriSize={width=170,height=170}
	--活动区域参数
	local area = {}
	area.width = Common.visibleSize.width-20
	area.height = area.width
	area.xNum = xNum
	area.yNum = yNum	
	--标定格子参数
	
	gridConfig.width = area.width/area.xNum
	gridConfig.height=gridConfig.width

	--以上参数以后从全局配置获取
	--原始格子的缩放比例
	scale = gridConfig.width/gridOriSize.width
	local startX = (Common.visibleSize.width - area.width)/2
	local startY = (Common.visibleSize.height - area.height)/2

	--生成格子
	for  key,gridObj in ipairs(gridObjs) do
		grid = CCSprite:createWithSpriteFrameName("grid.png");
		grid:setScale(scale)
		local gridSize = grid:getContentSize()			
		grid:setPosition(startX+gridConfig.width*(gridObj["x"]+0.5-1),startY+gridConfig.height*(gridObj["y"]+0.5-1))
		batchNode:addChild(grid)
		gridObj["sprite"] = grid
	end
end

local function createLevelData()
	reLoadLinkParam()
--随机生成objectslimit个点
	createGrids(false)
	local pointsList =  createPoints()
	createLines(pointsList)
	createLinkObj(false)
	if isConform() then 
		drawGrids()
		drawLinkObj()
	else 
		createLevelData()
	end	
end  

local function createLevel()
	createLevelData()
	local levelData=""
	for i=1,#tempSegments do 
		levelData=levelData..tempSegments[i]["keyword"]..";"..tempSegments[i]["mPoint"]["x"]..","..tempSegments[i]["mPoint"]["y"]..",;"..tempSegments[i]["img"]..";"
		local lines = tempSegments[i]["lines"]
		for j=1,#lines do
			local line = lines[j] 
			for k=1,#line do 
				levelData=levelData..line[k]["x"]..","..line[k]["y"]..","..line[k]["type"]..",:"
			end 
			levelData=levelData..";"
		end 
		levelData=levelData.."~"
	end
	isNoFinishMode = CCUserDefault:sharedUserDefault():getIntegerForKey("isNoFinishMode")
	if isNoFinishMode == 1 then 
		CCUserDefault:sharedUserDefault():setStringForKey("mission00_level00_data",levelData)
	else
		CCUserDefault:sharedUserDefault():setStringForKey("mission"..curMission.."_level"..curLevel.."_data",levelData)
	end
	
--[[
	cclog("tempSegments_len:"..#tempSegments)
	for key,value in ipairs(tempSegments) do 
		cclog("tempSegment;keyword:"..value.keyword)
		for k,v in ipairs(value["lines"]) do 
			for k1,v1 in ipairs(v) do 
				cclog("line;x:"..v1.x..",y:"..v1.y..",type:"..v1.type)
			end
		end 
	end 
--]]	
end

local function drawLine(preLinkGrid,curLinkGrid)

	local linkObj = fun_findObjInArrayByKeyword(linkObjs,curLinkword)["value"]
	local linkObjLine = linkObj["points"]
	local length = #linkObjLine
	local color = linkObj["color"]
	--画前一格的线
	if  preLinkGrid["type"]=="end" then 
		 local linkGrid = Common.copyTable(preLinkGrid)
		 local sprite = createLine(nil,preLinkGrid,curLinkGrid,color)
		 linkGrid["sprite"] = sprite 	 
		 linkObjLine[1]=linkGrid
	else
		local returnVal = fun_findObjInArrayByKeyword(linkObjLine,preLinkGrid["keyword"])
		local position = returnVal["position"]
		batchNode:removeChild(linkObjLine[position]["sprite"],true) 
		local sprite = createLine(prePreLinkGrid,preLinkGrid,curLinkGrid,color)
		linkObjLine[position]["sprite"]=sprite
	end
	--画后一格的线
	if  curLinkGrid["type"]=="end" then
		local linkGrid = Common.copyTable(curLinkGrid)
		local sprite = createLine(preLinkGrid,curLinkGrid,nil,color)
		linkGrid["sprite"] = sprite 
		linkObjLine[#linkObjLine+1] = linkGrid
	else 
		local linkGrid = Common.copyTable(curLinkGrid)
		linkGrid["preGrid"] = preLinkGrid
		local sprite = createLine(preLinkGrid,curLinkGrid,nil,color)
		linkGrid["sprite"] = sprite
		linkObjLine[#linkObjLine+1] = linkGrid
	end
end 

local function cleanGrids()
	for i=1,#linkObjs do 
		local linkObjLine = linkObjs[i]["points"]
		for j=1,#linkObjLine do 
			local sprite = linkObjLine[j]["sprite"]
			batchNode:removeChild(sprite,true)
		end 
	end 
end 

-- create mainLayer
local function createLayer()
	-- add in farm background
	local buttonSize = {width = 60,height = 60}
	local bg = CCSprite:create("img/space.jpg")
	bg:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 2)
	mainLayer = CCLayer:create()
	mainLayer:addChild(bg)
	--添加按钮
	local backButton = CCSprite:create("img/buttons/back.png")
	backButton:setPosition(10+buttonSize.width*0.5,Common.visibleSize.height-buttonSize.height/2-10)
	mainLayer:addChild(backButton)

	local reloadButton = CCSprite:create("img/buttons/reload.png")
	reloadButton:setPosition(10+buttonSize.width*1.5,Common.visibleSize.height-buttonSize.height/2-10)
	mainLayer:addChild(reloadButton)

	local helpButton = CCSprite:create("img/buttons/showLink.png")
	helpButton:setPosition(10+buttonSize.width*2.5,Common.visibleSize.height-buttonSize.height/2-10)
	mainLayer:addChild(helpButton)
	local showLinkTips = CCUserDefault:sharedUserDefault():getIntegerForKey("showLinkTips")
	showLinkTipsLabel = CCLabelTTF:create (showLinkTips, "Marker Felt", 40)
	local color = ccc3(160,83,253)
	showLinkTipsLabel:setColor(color)
	showLinkTipsLabel:setPosition(buttonSize.width/2,buttonSize.height/2)
	helpButton:addChild(showLinkTipsLabel)	

	local shareButton = CCSprite:create("img/buttons/share.png")
	shareButton:setPosition(10+buttonSize.width*3.5,Common.visibleSize.height-buttonSize.height/2-10)
	mainLayer:addChild(shareButton)

	local isCloseSound = CCUserDefault:sharedUserDefault():getIntegerForKey("isCloseSound")
	local soundImg
	if isCloseSound == 0 then 
		soundImg = "img/buttons/sound_open.png"
	else 
		soundImg = "img/buttons/sound_close.png"
	end 
	local soundButton = CCSprite:create(soundImg)
	soundButton:setPosition(Common.visibleSize.width - 60,Common.visibleSize.height-buttonSize.height/2-10)
	mainLayer:addChild(soundButton)

	mainLayer:setKeypadEnabled(true)
	mainLayer:registerScriptKeypadHandler(function(callback) Common.keyEventListener(callback) end) 

	local touchBeginPoint = nil

	local function onTouchBegan(x, y)			
  		local touchP = ccp(x,y) 
  		if isPlay then 
	        for key,value in ipairs(gridObjs) do      	
	        	if value["linkword"]  then
		        	local gridSprite = value["sprite"]
--		        	local gridSize = gridSprite:getContentSize()
--					local positionx,positiony =gridSprite:getPosition()
--					local worldPosition = gridSprite:getParent():convertToWorldSpace(ccp(positionx,positiony))
--		        	local rect = CCRectMake(worldPosition.x - gridSize.width*scale/2, worldPosition.y - gridSize.height*scale/2,gridSize.width*scale, gridSize.height*scale) 
		        	local boundingBox = gridSprite:boundingBox()	
		        	if boundingBox:containsPoint(touchP)  then 
		        		curMovedKeyword = value["keyword"] 
		        		curLinkword = value["linkword"]	
		        		preLinkGrid =  value
		        		linkObjs[fun_findObjInArrayByKeyword(linkObjs,curLinkword)["position"]]["lock"]=false
	        			local returnVal = fun_findObjInArrayByKeyword(linkObjs,curLinkword)
			        	local linkObj = returnVal["value"]
			        	local linkObjLine = returnVal["value"]["points"]
			        	local tempLinkObjLine = Common.copyArray(linkObjLine)
		        		if value["type"] == "end" then 
		        			if #linkObjLine > 0 then
			        			for pointPosition=#linkObjLine,1,-1 do 
				    				batchNode:removeChild(tempLinkObjLine[pointPosition]["sprite"],true)
				    				local gridObjVal = fun_findObjInArrayByKeyword(gridObjs,tempLinkObjLine[pointPosition]["keyword"])
				    				local gridPosition = gridObjVal["position"]
				    				if gridObjs[gridPosition]["type"]~="end" then 
				    					gridObjs[gridPosition]["linkword"]=nil
				    				end
				    				table.remove(linkObjLine,pointPosition)
				    			end
			    			end 
		        		else 
							local gridPosition = fun_findObjInArrayByKeyword(linkObjLine,value["keyword"])["position"] 		    			
			    			--重新设置当前格的前一格
			    			preLinkGrid = value
			    			prePreLinkGrid = linkObjLine[gridPosition]["preGrid"]
			    			local forPosition
			    			if value["type"] == "end" then 
			    				forPosition = gridPosition
			    			else 
			    				forPosition = gridPosition+1
			    			end 
			    			for pointPosition=#linkObjLine,forPosition,-1 do 
			    				batchNode:removeChild(tempLinkObjLine[pointPosition]["sprite"],true)
			    				local gridObjVal = fun_findObjInArrayByKeyword(gridObjs,tempLinkObjLine[pointPosition]["keyword"])
			    				local gridPosition = gridObjVal["position"]
			    				if gridObjs[gridPosition]["type"]~="end" then 
			    					gridObjs[gridPosition]["linkword"]=nil
			    				end
			    				table.remove(linkObjLine,pointPosition)
			    			end
		        		end      	
		        	end 
	       		end

	        end 
    	end

    	
		return true
	end

	local function onTouchMoved(x, y)
		local touchP = ccp(x,y) 

		if curLinkword then 
			for i=1,#gridObjs do
				local value = gridObjs[i]
				local gridSprite = value["sprite"]
--	        	local gridSize = gridSprite:getContentSize()
--				local positionx,positiony =gridSprite:getPosition()
--				local worldPosition = gridSprite:getParent():convertToWorldSpace(ccp(positionx,positiony))
--	        	local rect = CCRectMake(worldPosition.x - gridSize.width*scale/2, worldPosition.y - gridSize.height*scale/2,gridSize.width*scale, gridSize.height*scale) 
	        	local boundingBox = gridSprite:boundingBox()	        	       	
	        	if boundingBox:containsPoint(touchP) and value["keyword"] ~= curMovedKeyword  then	        		
	        		curMovedKeyword = value["keyword"]	
	        		--删除当前格之后的的连接
	        		if value["linkword"]  then 
	        			local returnVal = fun_findObjInArrayByKeyword(linkObjs,value["linkword"])
	        			local linkObj = returnVal["value"]
	        			local linkObjLine = returnVal["value"]["points"]
	        			if value["linkword"]==curLinkword then
	        					
	        				if  value["type"]=="end" and fun_findObjInArrayByKeyword(linkObjLine,value["keyword"]) == nil then
	        				elseif value["type"]=="end" and linkObj["lock"]==true then 

	        				else 			        			
			        			local linkObjLinPosition = fun_findObjInArrayByKeyword(linkObjLine,value["keyword"])["position"] 
			        			--重新设置当前格的前一格
			        			preLinkGrid = value
			        			prePreLinkGrid = linkObjLine[linkObjLinPosition]["preGrid"]		        			
			        			local forPosition
			        			if value["type"] == "end" then 
			        				forPosition = linkObjLinPosition
			        			else 
			        				forPosition = linkObjLinPosition+1
			        				linkObj["lock"] = false
			        			end
			        			for pointPosition=#linkObjLine,forPosition,-1 do 
			        				batchNode:removeChild(linkObjLine[pointPosition]["sprite"],true)
			        				local gridObjVal = fun_findObjInArrayByKeyword(gridObjs,linkObjLine[pointPosition]["keyword"])
			        				local gridPosition = gridObjVal["position"]
			        				if gridObjs[gridPosition]["type"]~="end" then 
			        					gridObjs[gridPosition]["linkword"]=nil			        					
			        				end
			        				table.remove(linkObjLine,pointPosition)
			        			end			        			
			        		end  
		        		else
		        			if  value["type"]~="end" then
		        				local curGridInLinkRvl =  fun_findObjInArrayByKeyword(linkObjLine,value["keyword"])
		        				if curGridInLinkRvl ~= nil then 
		        					linkObj["lock"] = false
				        			local curGridInLinkRvlPosition = curGridInLinkRvl["position"] 
				        			for pointPosition=#linkObjLine,curGridInLinkRvlPosition,-1 do 
				        				batchNode:removeChild(linkObjLine[pointPosition]["sprite"],true)
				        				local gridObjVal = fun_findObjInArrayByKeyword(gridObjs,linkObjLine[pointPosition]["keyword"])
				        				local gridPosition = gridObjVal["position"]
				        				if gridObjs[gridPosition]["type"]~="end" then 
				        					gridObjs[gridPosition]["linkword"]=nil
				        				end
				        				table.remove(linkObjLine,pointPosition)
				        			end 
			        			end 
		        			end 
		        		end
		        	end 
		        	local returnVal2 = fun_findObjInArrayByKeyword(linkObjs,curLinkword)
			        local linkObj2 = returnVal2["value"]
			        local linkObjLine2 = returnVal2["value"]["points"]
			        if 	(math.abs(preLinkGrid["x"] - value["x"])==1 or math.abs(preLinkGrid["y"] - value["y"])==1) and 
			        	(value["x"]==preLinkGrid["x"] or value["y"]==preLinkGrid["y"]) then 
			        	if value["linkword"]==nil then
			        		if linkObj2["lock"]~=true  then
				        		--画线及设置参数
								drawLine(preLinkGrid,value)
								value["linkword"] =  curLinkword
								prePreLinkGrid =  preLinkGrid
								preLinkGrid =  value
							end 	
			        	else 
		        			if value["linkword"]==curLinkword then
		        				if  value["type"]=="end" and fun_findObjInArrayByKeyword(linkObjLine2,value["keyword"]) == nil  and #linkObjLine2~=1 then
		        					--画线及设置参数
									drawLine(preLinkGrid,value)
									linkObj2["lock"] = true
								end 
							end 			        	
		        		end 
	        		end
	        		      			 
	        	end 
			end
		end

	end

	local function onTouchEnded(x, y)
		curLinkword = nil
	    preLinkGrid =  nil
	    curMovedKeyword = nil
		local touchP = ccp(x,y)
		local backBoundingBox = backButton:boundingBox()
		local reloadBoundingBox = reloadButton:boundingBox()
		local helpBoundingBox = helpButton:boundingBox()
		local shareBoundingBox = shareButton:boundingBox()
		local soundButtonBindBox = soundButton:boundingBox()
		if backBoundingBox:containsPoint(touchP) then 
			endScene()
			local levelScene
			if isNoFinishMode == 1 then 
				levelScene = MissionScene.createScene()
			else 
				levelScene = LevelScene.createScene()
			end 
			local transitionFade  = CCTransitionFade:create(1,levelScene) 
			
			CCDirector:sharedDirector():replaceScene(transitionFade)
		end 
		if reloadBoundingBox:containsPoint(touchP) then 
			endScene()
			CCUserDefault:sharedUserDefault():setIntegerForKey("isLoadNoFinishMode",1)
			CCUserDefault:sharedUserDefault():flush()
			local scene = MainScene.createScene()
			local transitionFade  = CCTransitionFade:create(1,scene) 
			CCDirector:sharedDirector():replaceScene(transitionFade)
		end 
		if helpBoundingBox:containsPoint(touchP) then 
			local showLinkTips = tonumber(CCUserDefault:sharedUserDefault():getIntegerForKey("showLinkTips"))
			if showLinkTips > 0 then 
			stopSchedule()
			cleanGrids()
			createSegment(true)
				showLinkTips = showLinkTips - 1
				CCUserDefault:sharedUserDefault():setIntegerForKey("showLinkTips",showLinkTips)
				CCUserDefault:sharedUserDefault():flush()
				showLinkTipsLabel:setString(showLinkTips)
			end
		end 
		if shareBoundingBox:containsPoint(touchP) then 			
			YoumiAd:shareButtonOnClick()
		end 

		if soundButtonBindBox:containsPoint(touchP) then 
			local isCloseSound = CCUserDefault:sharedUserDefault():getIntegerForKey("isCloseSound")
			if isCloseSound == 0 then
				AudioEngine.stopMusic(false)
				Common.changeButtonImage(soundButton,"img/buttons/sound_close.png")
				CCUserDefault:sharedUserDefault():setIntegerForKey("isCloseSound",1)							
			else 
				AudioEngine.playMusic(startEffectPath,true)
				Common.changeButtonImage(soundButton,"img/buttons/sound_open.png")
				CCUserDefault:sharedUserDefault():setIntegerForKey("isCloseSound",0)	
			end 
		end  

	end

	local function onTouch(eventType, x, y)
		if eventType == "began" then
			return onTouchBegan(x, y)
			elseif eventType == "moved" then
			return onTouchMoved(x, y)
			else
			return onTouchEnded(x, y)
		end
	end

	mainLayer:registerScriptTouchHandler(onTouch)
	mainLayer:setTouchEnabled(true)
	
	return mainLayer
end

local function stringToTable(data,synbol)
	local dataItem = string.gmatch(data,"[%w%p_]-"..synbol)
	local temp = {}
	for v in dataItem do
		v = string.gsub(v,synbol,"") 
		table.insert(temp,v)
	end 
	return temp
end 

local function loadLevel(levelData)
	createGrids(true)
	local datas = string.gmatch(levelData,"[%w%p_]-~")
	for data in datas do 
		data = string.gsub(data,"~","")
		
		local tempSegmentTemp = stringToTable(data,";")
		local tempSegment = {}
		tempSegment["keyword"]=tempSegmentTemp[1]
		local mPoint = stringToTable(tempSegmentTemp[2],",")
		tempSegment["mPoint"]={}
		tempSegment["mPoint"]["x"] = mPoint[1]
		tempSegment["mPoint"]["y"] = mPoint[2]
		tempSegment["mPoint"]["keyword"] = mPoint[1]..","..mPoint[2]
		tempSegment["img"]=tempSegmentTemp[3]
		--需要实现
		tempSegment["color"]=Common.findObjInArrayByFindword(imgs,"fileName",tempSegment["img"])["value"]["color"]
		tempSegment["lines"] = {}
		local line1Temp = stringToTable(tempSegmentTemp[4],":")
		local line1 = {}		
		for k,v in ipairs(line1Temp) do 
			v = string.gsub(v,":","") 
			local pointTemp = stringToTable(v,",")
			local point ={}
			point["x"] = pointTemp[1]
			point["y"] = pointTemp[2]
			point["type"] = pointTemp[3]
			point["keyword"] = point["x"]..","..point["y"]
			line1[k]=point
		end
		tempSegment["lines"][1] = line1
		local line2Temp = stringToTable(tempSegmentTemp[5],":")
		local line2 = {}		
		for k,v in ipairs(line2Temp) do 
			v = string.gsub(v,":","") 
			local pointTemp = stringToTable(v,",")
			local point ={}
			point["x"] = pointTemp[1]
			point["y"] = pointTemp[2]
			point["type"] = pointTemp[3]
			point["keyword"] = point["x"]..","..point["y"]
			line2[k]=point
		end
		tempSegment["lines"][2] = line2
		table.insert(tempSegments,tempSegment)
	end 
	createLinkObj(true)

end 

-- create mainLayer
function MainScene.createScene()

	local mainScene = CCScene:create()
	mainScene:addChild(createLayer())
	initParams()

	batchNode = CCSpriteBatchNode:create("img/grids/grids.png")
	mainLayer:addChild(batchNode)
	frameCache  = CCSpriteFrameCache:sharedSpriteFrameCache()
	frameCache:removeSpriteFrames()	
	frameCache:addSpriteFramesWithFile("img/grids/grids.plist")

	
	
	isNoFinishMode = CCUserDefault:sharedUserDefault():getIntegerForKey("isNoFinishMode")
	local isLoadNoFinishMode = CCUserDefault:sharedUserDefault():getIntegerForKey("isLoadNoFinishMode")
	local levelData
	if isNoFinishMode == 1 then 
		levelData=CCUserDefault:sharedUserDefault():getStringForKey("mission00_level00_data")
	else
		levelData=CCUserDefault:sharedUserDefault():getStringForKey("mission"..curMission.."_level"..curLevel.."_data")
	end

	if levelData == ""  then 
		createLevel()
	elseif isNoFinishMode == 1  then 
		if isLoadNoFinishMode == 0 then 
			createLevel()
		else 
			loadLevel(levelData)
		end 
	else 
		loadLevel(levelData)
	end 
	startSchdeule()
	Common.runScene(mainScene)
	YoumiAd:showBanner()
	return mainScene
end

--将successScene注册到全局对象表中
local modename = "MainScene"
local proxy = {}
local mt    = {
    __index = MainScene,
    __newindex =  function (t ,k ,v)
        print("attemp to update a read-only table")
    end
} 
setmetatable(proxy,mt)
_G[modename] = proxy
package.loaded[modename] = proxy