local MissionScene = {}

local mainLayer
local buttons={}

local buttonImgs


-- create mainLayer
local function createStartLayer()
	local isAllMissionDone = CCUserDefault:sharedUserDefault():getIntegerForKey("isAllMissionDone")
	local bg = CCSprite:create("img/level/missionBg.jpg")
	bg:setPosition(Common.visibleSize.width / 2 ,Common.visibleSize.height / 2)
	mainLayer = CCLayer:create()
	mainLayer:addChild(bg)
	mainLayer:setKeypadEnabled(true)
	mainLayer:registerScriptKeypadHandler(function(callback) Common.keyEventListener(callback) end) 

	local backButton = CCSprite:create("img/buttons/back.png")
	local backButtonSize = backButton:getContentSize()
	backButton:setPosition(10+backButtonSize.width/2,Common.visibleSize.height-backButtonSize.height/2-10)
	mainLayer:addChild(backButton)

	for k,v in ipairs(buttonImgs) do
		local button = {}
		local sprite = CCSprite:create(v)
		local spriteSize = sprite:getContentSize()
		sprite:setPosition(Common.visibleSize.width / 2 ,30 + spriteSize.height*1.5*k)
		mainLayer:addChild(sprite)
		button["sprite"] = sprite
		button["objectslimit"] = k + 5 + 1
		button["mission"] = k + 5		
		table.insert(buttons,button)
	end
	local maxSpriteImg = "img/level/m_max_dis.png"
	if isAllMissionDone == 1 then 
		maxSpriteImg = "img/level/m_max.png"
	end 
	local maxSprite = CCSprite:create(maxSpriteImg)
	local maxSpriteSize = maxSprite:getContentSize()
	maxSprite:setPosition(Common.visibleSize.width / 2 ,30 + maxSpriteSize.height*1.5*5)
	mainLayer:addChild(maxSprite)
	

	local backButtonBindBox = backButton:boundingBox()
	local maxSpriteBindBox = maxSprite:boundingBox()

	local function onTouchBegan(x, y)			
		return true
	end

	local function onTouchMoved(x, y)

	end

	local function onTouchEnded(x, y)
		local touchP = ccp(x,y)
		for k,v in ipairs(buttons) do 
			if Common.isBeTouched(touchP,v["sprite"])   then
				CCUserDefault:sharedUserDefault():setIntegerForKey("objectslimit",v["objectslimit"])
				CCUserDefault:sharedUserDefault():setIntegerForKey("curMission",v["mission"])
				CCUserDefault:sharedUserDefault():setIntegerForKey("isNoFinishMode",0)
				CCUserDefault:sharedUserDefault():flush()
				local mainScene = LevelScene.createScene()
				local transitionFade  = CCTransitionFade:create(1,mainScene) 
				CCDirector:sharedDirector():replaceScene(transitionFade)
			end 
			
		end 

		if maxSpriteBindBox:containsPoint(touchP) then 
			CCUserDefault:sharedUserDefault():setIntegerForKey("isLoadNoFinishMode",0)
			CCUserDefault:sharedUserDefault():setIntegerForKey("isNoFinishMode",1)
			CCUserDefault:sharedUserDefault():setIntegerForKey("curMission",4 + 5)
			CCUserDefault:sharedUserDefault():setIntegerForKey("objectslimit",4 + 5 + 1)

			CCUserDefault:sharedUserDefault():flush()
			local mainScene = MainScene.createScene()
			local transitionFade  = CCTransitionFade:create(1,mainScene) 
			CCDirector:sharedDirector():replaceScene(transitionFade)
		end 

		if backButtonBindBox:containsPoint(touchP) then 
			local mssionScene = StartScene.createScene()
			local transitionFade  = CCTransitionFade:create(1,mssionScene) 
			CCDirector:sharedDirector():replaceScene(transitionFade)
		end 
	end

	local function onTouch(eventType, x, y)
		if eventType == "began" then
			return onTouchBegan(x, y)
			elseif eventType == "moved" then
			return onTouchMoved(x, y)
			else
			return onTouchEnded(x, y)
		end
	end

	mainLayer:registerScriptTouchHandler(onTouch)
	mainLayer:setTouchEnabled(true)
	
	return mainLayer
end

local function init()
	buttons={}
	buttonImgs={"img/level/m_6.png", "img/level/m_7.png", "img/level/m_8.png","img/level/m_9.png"}
end 

function MissionScene.createScene()
	init()
	local scene = CCScene:create()
	scene:addChild(createStartLayer())
	Common.runScene(scene)
	return scene
end

--将successScene注册到全局对象表中
local modename = "MissionScene"
local proxy = {}
local mt    = {
    __index = MissionScene,
    __newindex =  function (t ,k ,v)
        print("attemp to update a read-only table")
    end
} 
setmetatable(proxy,mt)
_G[modename] = proxy
package.loaded[modename] = proxy




